<?php


// **********************************************************************************
// *                                                                                *
// *   CONJUNTO DE FUNES QUE ANALISAM UMA FUNO MATEMTICA (a varivel $formula) *
// *   DIGITADA NO FORMULRIO E, EM SEGUIDA, CALCULAM SEU VALOR PARA CADA VALOR DE  *
// *   X APLICADO  MESMA.                                                          *
// *                                                                                *
// *   www.jailson.mat.br                                                           *
// **********************************************************************************



function ConverterStringParaReal($str, $valor, $code)
{
 // Converte $str (string) para real (double).

 if (strpos($str,'E') == 0)
    {
     $strR = $str + '$E0';
     $valor = (double) $strR;
    }
 else
     $valor = (double) $strR;

 return $valor;

}     //........... FIM da ConverterStringParaReal .........



function PularPosicao()
{
  global $ch, $p, $formula;
      $p = $p + 1;
      if ($p <= (strlen($formula)-1))
         {
           $ch = $formula[$p];
         }
      else
         {
           $ch = "";
         }
} //........... FIM da PularPosicao ............



function ProcessarNumeros()
{
  global $ch, $valor, $formula, $p;

  $codigo = 0;
  $inicia = $p;
  do {
      PularPosicao();
      if ($ch == "")
         {
          Break;
         }
      else if (!is_numeric($ch))
         {
          Break;
         }
     } while (is_numeric($ch));

  if ($ch == '.')
     do {
         PularPosicao();
        } while (is_numeric($ch));

  if ($ch == 'E')
     {
       PularPosicao();
       do {
           PularPosicao();
          } while (is_numeric($ch));
     }
  $result = ConverterStringParaReal(substr($formula, $inicia, $p-$inicia), $valor, $codigo);
  return $result;

} //............ FIM da ProcessarNumeros ..............



function ProcessarNovaExpressao()
{
  global $f, $p, $ch;

  PularPosicao();
  $f = Expressao();
  if ($ch == ')')
    PularPosicao();
  else
    $PararNoPonto = $p;
 return $f;
} //............ ProcessarNovaExpressao ............



function Fatorial($I)
{
 if ($I > 0)
    $fator = $I*Fatorial($I - 1);
 else
    $fator = 1;
 return $fator;
} //...........FIM da Fatorial............



function ProcessarFuncoesInternas()
{
  global $ch, $p, $formula, $x1, $f, $erro2, $PararNoPonto;

  if (substr($formula, $p, 3) == 'ABS')
     {
       $p = $p + 2;
       PularPosicao();
       $f = Fatores();
       $f = abs($f);
     }
  else
   if (substr($formula, $p, 4) == 'SQRT')
      {
       $p = $p + 3;
       PularPosicao();
       $f = Fatores();
       if ($f >= 0)
          $f = sqrt($f);
       else
          {
           $PararNoPonto = $p;
           $erro2 = True;
          }
      }
  else
  if (substr($formula, $p, 3) == 'SEN')
     {
      $p = $p + 2;
      PularPosicao();
      $f = Fatores();
      $f = sin($f);
     }
  else
  if (substr($formula, $p, 3) == 'SIN')
     {
      $p = $p + 2;
      PularPosicao();
      $f = Fatores();
      $f = sin($f);
     }
  else
  if (substr($formula, $p, 3) == 'COS')
     {
      $p = $p + 2;
      PularPosicao();
      $f = Fatores();
      $f = cos($f);
     }
  else
  if (substr($formula, $p, 3) == 'TAN')
     {
      $p = $p + 2;
      PularPosicao();
      $f = Fatores();
      if (cos($f) <> 0) $f = tan($f);
      else
         {
          $PararNoPonto = $p;
          $erro2 = True;
         }
     }
  else
  if (substr($formula, $p, 5) == 'COTAN')
     {
      $p = $p + 4;
      PularPosicao();
      $f = Fatores();
      if (sin($f) <> 0) $f = (1.0)/tan($f);
      else $erro2 = True;
     }
  else
  if (substr($formula, $p, 3) == 'SEC')
     {
      $p = $p + 2;
      PularPosicao();
      $f = Fatores();
      if (cos($f) <> 0) $f = (1.0)/cos($f);
      else $erro2 = True;
     }
  else
  if (substr($formula, $p, 3) == 'CSC')
     {
      $p = $p + 2;
      PularPosicao();
      $f = Fatores();
      if (sin($f) <> 0) $f = (1.0)/sin($f);
      else $erro2 = True;
     }
  else
  if (substr($formula, $p, 6) == 'ARCSEN')
     {
      $p = $p + 5;
      PularPosicao();
      $f = Fatores();
      if (abs($f) < 1) $f = asin($f);
      else $erro2 = True;
     }
  else
  if (substr($formula, $p, 6) == 'ARCCOS')
     {
      $p = $p + 5;
      PularPosicao();
      $f = Fatores();
      if (abs($f) < 1) $f = acos($f);
      else $erro2 = True;
     }
  else
  if (substr($formula, $p, 6) == 'ARCTAN')
     {
      $p = $p + 5;
      PularPosicao();
      $f = Fatores();
      $f = atan($f);
     }
  else
  if (substr($formula, $p, 8) == 'ARCCOTAN')
     {
      $p = $p + 7;
      PularPosicao();
      $f = Fatores();
      $f = (3.141592653)/(2.0) - atan($f);
     }
  else
  if (substr($formula, $p, 6) == 'ARCSEC')
     {
      $p = $p + 5;
      PularPosicao();
      $f = Fatores();
      if (abs($f) > 1) $f = acos((1.0)/($f));
      else $erro2 = True;
     }
  else
  if (substr($formula, $p, 8) == 'ARCOSSEC')
     {
      $p = $p + 7;
      PularPosicao();
      $f = Fatores();
      if (abs($f) > 1) $f = asin((1.0)/($f));
      else $erro2 = True;
     }
  else
  if (substr($formula, $p, 2) == 'SH')
     {
      $p = $p + 1;
      PularPosicao();
      $f = Fatores();
      $f = sinh($f);
     }
  else
  if (substr($formula, $p, 2) == 'CH')
     {
      $p = $p + 1;
      PularPosicao();
      $f = Fatores();
      $f = cosh($f);
     }
  else
  if (substr($formula, $p, 2) == 'TH')
     {
      $p = $p + 1;
      PularPosicao();
      $f = Fatores();
      $f = tanh($f);
     }
  else
  if (substr($formula, $p, 3) == 'CTH')
     {
      $p = $p + 2;
      PularPosicao();
      $f = Fatores();
      if (sinh($f) <> 0) $f = cosh($f)/sinh($f);
      else $erro2 = True;
     }
  else
  If (substr($formula, $p, 3) == 'SCH')
     {
      $p = $p + 2;
      PularPosicao();
      $f = Fatores();
      $f = 1/cosh($f);
     }
  else
  if (substr($formula, $p, 5) == 'CSSCH')
     {
      $p = $p + 4;
      PularPosicao();
      $f = Fatores();
      if (sinh($f) <> 0) $f = 1/sinh($f);
      else $erro2 = True;
     }
  else
  if (substr($formula, $p, 3) == 'ASH')
     {
      $p = $p + 2;
      PularPosicao();
      $f = Fatores();
      $f = asinh($f);
     }
  else
  if (substr($formula, $p, 3) == 'ACH')
     {
      $p = $p + 2;
      PularPosicao();
      $f = Fatores();
      $f = acosh($f);
     }
  else
  if (substr($formula, $p, 3) == 'ATH')
     {
      $p = $p + 2;
      PularPosicao();
      $f = Fatores();
      if (abs($f) < 1) $f = atanh($f);
      else $erro2 = True;
     }
  else
  if (substr($formula, $p, 4) == 'ACTH')
     {
      $p = $p + 3;
      PularPosicao();
      $f = Fatores();
      if (abs($f) > 1) $f = log(abs(($f+1)/($f-1)))/2;
      else $erro2 = True;
     }
  else
  if (substr($formula, $p, 4) == 'ASCH')
     {
      $p = $p + 3;
      PularPosicao();
      $f = Fatores();
    // if (($f > 0) and ($f <= 1) ) $f = log(abs((1+sqrt(1-($f^2)))/$f));
      if (($f > 0) and ($f <= 1) ) $f = acosh((1.0)/($f));
      else $erro2 = True;
     }
  else
  if (substr($formula, $p, 6) == 'ACSSCH')
     {
      $p = $p + 5;
      PularPosicao();
      $f = Fatores();
    // if ($f <> 0) $f = log(abs((1-sqrt(1+$f^2))/$f));
      if ($f <> 0) $f = asinh((1.0)/($f));
      else $erro2 = True;
     }
  else
  if (substr($formula, $p, 2) == 'LN')
     {
      $p = $p + 1;
      PularPosicao();
      $f = Fatores();
      if ($f > 0) $f = log($f);
      else
         {
           $erro2 = True;
           // echo "&nbsp;&nbsp;&nbsp;&nbsp; <FONT COLOR='#FF0000'>Resultado invlido!<br>
           //                                  Verifique se o intervalo est no domnio da funo</FONT>";
           // exit;
         }
     }
  else
  if (substr($formula, $p, 5) == 'LOG10')
     {
      $p = $p + 4;
      PularPosicao();
      $f = Fatores();
      if ($f > 0) $f = log($f)/log(10);
      else
         {
           $erro2 = True;
           // echo "&nbsp;&nbsp;&nbsp;&nbsp; <FONT COLOR='#FF0000'>Resultado invlido!<br>
           //                                  Verifique se o intervalo est no domnio da funo</FONT>";
           // exit;
         }
     }
  else
  if (substr($formula, $p, 4) == 'LOG2')
     {
      $p = $p + 3;
      PularPosicao();
      $f = Fatores();
      if ($f > 0) $f = log($f)/log(2);
      else
         {
           $erro2 = True;
           // echo "&nbsp;&nbsp;&nbsp;&nbsp; <FONT COLOR='#FF0000'>Resultado invlido!<br>
           //                                  Verifique se o intervalo est no domnio da funo</FONT>";
           // exit;
         }
     }
  else
  if (substr($formula, $p, 3) == 'EXP')
     {
      $p = $p + 2;
      PularPosicao();
      $f = Fatores();
      $f = exp($f);
     }
  else
  if (substr($formula, $p, 4) == 'FATORIAL')
     {
      $p = $p + 3;
      PularPosicao();
      $f = Fatores();
      if ($f >= 0)
         {
          $f_int = (int) $f;
          $f = Fatorial($f_int);
         }
      else
         {
          $erro2 = True;
         }
     }
  else
  if (substr($formula, $p, 1) == 'X')
     {
      PularPosicao();
      $f = $x1;
     }
  else
   if (substr($formula, $p, 2) == 'PI')
      {
       $p = $p + 1;
       PularPosicao();
       $f = 3.1415926535897932;
      }
  else
     {
      $PararNoPonto = $p;
      $ch = "";
     }

  return $f;
} //......... FIM da ProcessarFuncoesInternas .........



function Potencia($b, $e)
{
  $r = 1;
  $ab = abs($e);
  $ab_part_int = (int) $ab;
  $ab_part_dec = $ab - $ab_part_int;
  if ($ab_part_dec == 0)
     {
      $ab = $ab_part_int;
      for ($i = 1; $i <= $ab; $i++) $r = $r*$b;
      if (($e < 0) & ($r <> 0)) $r = 1/$r;
      if (($r == 0) & ($e < 0)) $erro2 = True;
     }
  else
     {
      if ($b > 0)
         $r = exp(log($b)*$e);
      else
         {
          if ($b<0)
              $r = -exp(log(-$b)*$e);
          else
              $erro2 = True;
         }
     }
  return $r;
} //............ FIM da Potencia ............



function Fatores()
{
  global $ch, $p, $f;

  if (is_numeric($ch))
     $f = ProcessarNumeros();
  else if ($ch == '(')
     $f = ProcessarNovaExpressao();
  else
     $f = ProcessarFuncoesInternas();

  return $f;
} //............ FIM da Fatores ............



function S_Fatores()
{
 global $ch;

  if ($ch == '-')
     {
      PularPosicao();
      $Fa = -Fatores();
     }
  else
      $Fa = Fatores();

  return $Fa;
} //............FIM da S_Fatores...........



function Termo()
{ global $ch;
  $t = S_Fatores();

  while ($ch == '^')
        {
         PularPosicao();
         $t = Potencia($t, S_Fatores());
        }

  return $t;
} //............FIM da Termo............



function ExpressaoSimples()
{ global $ch;
  $s = Termo();

  while ($ch == '*' | $ch == '/')
        {
         $operador = $ch;
         PularPosicao();
         switch ($operador)
                {
                 case '*' : $s = $s*Termo();
                            break;
                 case '/' : {
                             $valor = Termo();
                             if ($valor <> 0)
                                $s = $s/$valor;
                             else
                                $erro2 = True;
                            }
                            break;
                }
        }
  return $s;
} //............FIM da ExpressaoSimples............



function Expressao()
{ global $ch;
  $e = ExpressaoSimples();

  while ($ch == '+' | $ch == '-')
  {
    $operador = $ch;
    PularPosicao();
    switch ($operador)
           {
            case '+' : $e = $e + ExpressaoSimples();
                       break;
            case '-' : $e = $e - ExpressaoSimples();
                       break;
           }
  }
  return $e;
} //............FIM da Expressao............



function AnalisarFormula($formula, $x1, $PararNoPonto)
{
  global $formula, $p, $ch, $PararNoPonto;

  $erro2 = False;

  for ($i = 0; $i <= strlen($formula)-1; $i++)
      {
       $formula[$i] = strtoupper($formula[$i]);
       if ($formula[$i] == ',') $formula[$i] = '.';
      }
  if ($formula[0] == '.') $formula = '0' . $formula;
  if ($formula[0] == '+') $formula[0] = str_ireplace("+"," ", $formula[0]);
  $formula = str_ireplace(" ","", $formula);  // remove espaos em branco.

  $p = 0;
  if ($p <= (strlen($formula)-1))
     $ch = $formula[$p];
  else
     $ch = "";

  $valor_expressao = Expressao();
  if ($ch == "")
    $erro1 = False;
  else
    {
     $erro1 = True;
     // echo "Funo invlida!";
    }
  $PararNoPonto = $p;

  return $valor_expressao;
} //............ FIM da AnalisarFormula ............



function ComputarFormula($p, $strg, $x1, $erro1, $erro2)
{
        //  Retorna o valor da funao strg (string) de variavel x quando
        //  x = $x1 (double), onde:
        //      * $p (tipo integer) contm o ponto onde ocorreu o erro;
        //      * $strg (tipo string) contm a funo informada ();
        //      * $x1 (tipo double)  cada valor atribuido automaticamente a x;
        //      * $erro1 (tipo boolean)  verdadeiro se a funao  invlida;
        //      * $erro2 (tipo boolean)  verdadeiro se o resultado nao pertence aos REAIS.

 global $p, $strg, $x1, $erro1, $erro2;
 $resul = AnalisarFormula($strg, $x1, $p);
 return $resul;

} //............ FIM da ComputarFormula ............

//*************** FIM DO CONJUNTO DE FUNES DE ANLISE ************************



header("Content-type: image/png");              // Informa ao navegador o tipo de imagem que vai ser criada.

$funcao1 = $_POST['funcao1'];                  // A varivel $funcao1 recebe a funo (tipo string).
$funcao1 = str_ireplace(" ","",$funcao1);      // Remove os espaos em branco contidos na funo.
$funcao2 = $_POST['funcao2'];                  // A varivel $funcao2 recebe a funo (tipo string).
$funcao2 = str_ireplace(" ","",$funcao2);      // Remove os espaos em branco contidos na funo.
$funcao3 = $_POST['funcao3'];                  // A varivel $funcao3 recebe a funo (tipo string).
$funcao3 = str_ireplace(" ","",$funcao3);      // Remove os espaos em branco contidos na funo.


global $ax, $bx, $ay, $by, $Altura, $Largura, $p, $formula, $x1, $erro1, $erro2;


// Cria o ambiente de imagem:

$imagem = imagecreatetruecolor(500, 400);

$fundoCorBranca = imagecolorallocate($imagem, 255, 255, 255);
imagefill($imagem,0,0,$fundoCorBranca);
$corAmarela = imagecolorallocate($imagem, 255, 255, 33);
$corAzul1 = imagecolorallocate($imagem, 0, 0, 200);
$corAzul2 = imagecolorallocate($imagem, 198, 226, 255);
$corPreta = imagecolorallocate($imagem, 0, 0, 0);
$corVermelha = imagecolorallocate($imagem, 255, 0, 0);
$corVerde = imagecolorallocate($imagem, 0, 160, 0);

$Largura  = 500;
$Altura   = 400;
$DominioX = 10;
$DominioY = 10;
$ax       = $Largura/(2*$DominioX);
$bx       = $Largura/2;
$ay       = -($Altura)/(2*$DominioY);
$by       = $Altura/2;

// Plota as linhas verticais e as horizontais (a malha).
$meiaAltura = (integer) $Altura/2;
$meiaLargura = (integer) $Largura/2;
for ($i = -($DominioX); $i <= $DominioX; $i++)
    {
     $Cx = round($i*$ax + $bx);
     imageLine($imagem, $Cx, 0, $Cx, $Altura, $corAzul2);
    }
for ($i = -($DominioY); $i <= ($DominioY-1); $i++)
    {
     $Cy = round($i*$ay + $by);
     imageLine($imagem, 0, $Cy, $Largura, $Cy, $corAzul2);
    }


// Plota os eixos das coordenadas x e y.
$meiaAltura = (integer) $Altura/2;

imagesetthickness($imagem, 1);   // espessura da lina: 1 pixel.

imageLine($imagem, 0, $meiaAltura, $Largura, $meiaAltura, $corPreta);
$meiaLargura = (integer) $Largura/2;
imageLine($imagem, $meiaLargura, $Altura, $meiaLargura, 0, $corPreta);
imageString($imagem, 6, 257, 0,"Y", $corPreta);
imageString($imagem, 9, 490, 200,"x", $corPreta);




// Calcula os pontos para gerar o grafico:

function CalcularGrafico($formula, $variavel, $pa)
{
        // $formula  string; $variavel e $pa so inteiros.

  global $ax, $bx, $ay, $by, $Altura, $Largura, $p, $formula, $x1, $erro1, $erro2;

  $x1 = 0.0;
  $erro1 = False;
  $erro2 = False;
  $p = 0;

  $x1 = ($variavel - $bx)/$ax;
  $y1 = ComputarFormula($p, $formula, $x1, $erro1, $erro2);
  $Cy = $y1*$ay + $by;
  $meiaAltura = (integer) $Altura/2;
  if (!$erro2)
     {
      if ($Cy > $Largura) $Cy = $Largura;
      if ($Cy < 0)  $Cy = 0;
     }
  else
     if ($pa < $meiaAltura) $Cy = 0;
        else $Cy = $Altura;

  return round($Cy);

} // --------- FIM da CalcularGrafico -----------




// Plota o grfico da funo 1:

imagesetthickness($imagem, 1);
$formula = $funcao1;
if ($formula == "")
   {
   }
else
   {
    $pa = CalcularGrafico($formula,0, 0);
    $pt_ant = $pa;
    for ($i = 1; $i <= $Largura; $i++)
        {
         $pt = CalcularGrafico($formula,$i, $pa);
         if (($pa >= 1 && $pa <= 399) || ($pt >= 1 && $pt <= 399)) imageLine($imagem, $i, $pt_ant, $i+1, $pt, $corVermelha);
         $pa = $pt;
         $pt_ant = $pt;
        }
   }


// Plota o grfico da funo 2:

imagesetthickness($imagem, 1);
$formula = $funcao2;
if ($formula == "")
   {
   }
else
   {
    $pa = CalcularGrafico($formula,0, 0);
    $pt_ant = $pa;
    for ($i = 1; $i <= $Largura; $i++)
        {
         $pt = CalcularGrafico($formula,$i, $pa);
         if (($pa >= 1 && $pa <= 399) || ($pt >= 1 && $pt <= 399)) imageLine($imagem, $i, $pt_ant, $i+1, $pt, $corAzul1);
         $pa = $pt;
         $pt_ant = $pt;
        }
   }

// Plota o grfico da funo 3:

imagesetthickness($imagem, 1);
$formula = $funcao3;
if ($formula == "")
   {
   }
else
   {
    $pa = CalcularGrafico($formula,0, 0);
    $pt_ant = $pa;
    for ($i = 1; $i <= $Largura; $i++)
        {
         $pt = CalcularGrafico($formula,$i, $pa);
         if (($pa >= 1 && $pa <= 399) || ($pt >= 1 && $pt <= 399)) imageLine($imagem, $i, $pt_ant, $i+1, $pt, $corVerde);
         $pa = $pt;
         $pt_ant = $pt;
        }
   }


// Mostra funes
//imageString($imagem, 5, 20, 6,"f(x) = ".$funcao, imagecolorallocate($imagem, 255, 99, 71));

// Mostra a conveno
imageString($imagem, 8, 490, 303,"f", $corVermelha);
imageFilledRectangle($imagem, 465, 310, 480, 313, $corVermelha);
imageString($imagem, 8, 490, 320,"g", $corAzul1);
imageFilledRectangle($imagem, 465, 328, 480, 331, $corAzul1);
imageString($imagem, 8, 490, 337,"h", $corVerde);
imageFilledRectangle($imagem, 465, 346, 480, 349, $corVerde);


// Mostra endereo do site
//imageString($imagem, 2, 380, 385,"www.jailson.mat.br", imagecolorallocate($imagem, 30, 144, 255));

// Mostra a imagem no navegador:
imagePng($imagem);

// Salva a imagem em arquivo:
$arquivo = "grafico2d_gerado.png";
imagePng($imagem,$arquivo);

// Remove a imagem da memria:
imagedestroy($imagem);
exit;
?>
